﻿using System;
using System.Diagnostics;
using System.Threading.Tasks;

namespace SimpleSort
{
    


    class Program
    {
        static void Main(string[] args)
        {
            int size = 20000; 
            int[] array = new int[size];

            //SortData.Print(array);

            // Simple sort in sequential way
            SortData.FillArray(array); //fill array with random numbers
            SortData sd = new SortData(array, size, 0, 0, size); //sort parameter for whole array
            Stopwatch sw = new Stopwatch(); //my chronometer :) 
            sw.Start();
            SimpleSort.Sort(sd); 
            Console.WriteLine($"Simple sort in {sw.ElapsedMilliseconds} ms");

            // Merge sort in sequential way. First left part after that right part
            SortData.FillArray(array); //new random data
            SortData sdR = new SortData(array, size, size / 2, 0, size); //sort parameter for left side of the array
            SortData sdL = new SortData(array, size, 0, 0, size / 2); //sort parameter for right side of the array
            SortData sdM = new SortData(array, size, 0, size / 2, size); //sort parameter for merge (whole array with middle point).
            sw.Restart();
            SimpleSort.Sort(sdL);
            SimpleSort.Sort(sdR);
            SimpleSort.Merge(sdM);
            Console.WriteLine($"Sequential merge sort sort in {sw.ElapsedMilliseconds} ms");

            //Parallel merge sort
            SortData.FillArray(array); 
            sdR = new SortData(array, size, size / 2, 0, size);
            sdL = new SortData(array, size, 0, 0, size / 2);
            sdM = new SortData(array, size, 0, size / 2, size);
            sw.Restart();
            Task t1 = Task.Factory.StartNew((o) =>
            {
                SortData parameterIn = (SortData)o;
                SimpleSort.Sort(parameterIn);
            }, sdL); //pass object as parameter to the task

            Task t2 = Task.Factory.StartNew((o) =>
            {
                SortData parameterIn = (SortData)o;
                SimpleSort.Sort(parameterIn);
            }, sdR); //pass object as parameter to the task
            
            t1.Wait(); //before merge we have to wait for results.
            t2.Wait();
            SimpleSort.Merge(sdM);
            Console.WriteLine($"Parallel merge sort in {sw.ElapsedMilliseconds} ms");

            Console.ReadLine();
           // SortData.Print(sdM.ArrayOfInts);
            
        }
    }
}
